How to create a StackOverflowException. And how to figure out where it is happening.

How to create a StackOverflowException. And how to figure out where it is happening.

Rate This
  • Comments 1

StackOverflowException.

 

This usually means that you have a recursive call in your code.

A recursion is simply a method that calls itself, causing the stack to overflow and throw the StackoverFlow exception.

 

A simple example:

 

namespace SimpleDemo

{

    class Program

    {

        static void Main(string[] args)

        {

            int i = RecursiveMethod();

        }

 

        private static int RecursiveMethod()

        {

            return RecursiveMethod();

        }

    }

}

 

Here it is fairly easy to see what is calling itself and thus being simple to fix.

However, sometimes it is not as clear. It can be a event that triggers itself or an exception that is triggering a new exception of the same kind.

Another simple example that demonstrates an exception that causes a new exception which leads to recursion and failure:

 

namespace StackOverflowDemo

{

    class Program

    {

        static void Main(string[] args)

        {

            Console.WriteLine("Any key to crash");

            Console.ReadLine();

 

            List<Person> persons = new List<Person>();

            persons.Add(new Person { Age = 30, Name = "Paul Paulson" });

            persons.Add(new Person { Age = 10, Name = "John Johnson" });

            persons.Add(new Person { Age = 20, Name = "Eric Ericson" });

 

            foreach (Person p in persons)

            {

                try

                {

                    p.GetAge();

                    Console.WriteLine("{0} is {1} years old", p.Name, p.Age);

                }

                catch (ToYoungException tye)

                {  /* Write to log or something similar */ }

            }

        }

    }

 

    class Person

    {

        public int Age { get; set; }

        public string Name { get; set; }

 

        public int GetAge()

        {

            if (this.Age < 18)

            {

                throw new ToYoungException(this);

            }

            return this.Age;

        }

    }

 

    class ToYoungException : Exception

    {

        public ToYoungException(Person p)

        {

            Console.WriteLine("{0} is too young. Minumum age is 18, {0} is only {1}.", p.Name, p.GetAge());

        }

    }

}

 

Again, not supercomplicated. When checking a persons age to see if they are under aged an exception is thrown. Possibly to send information to a log or something similar.

However, when writing the output the coder has made a mistake and calls the GetAge() method again on an instance of a Person that is under age.

Which again throws the exception and then again triggers a new exception. And you will have the stack overflow.

 

The code is not intended to be best practice or anything. It is just to demonstrate a simple scenario where it is not obvious where it goes wrong.

It could for example be that the classes are in difference assemblies or namespaces etc.

 

One of the problems with StackoverflowExceptions can be found in the documentation.

 

StackOverflowException Class”

http://msdn.microsoft.com/en-us/library/system.stackoverflowexception.aspx

 

“Starting with the .NET Framework version 2.0, a StackOverflowException object cannot be caught by a try-catch block and the corresponding process is terminated by default.”

 

So it is a bit hard to protect against since the process goes away when the exception occurs.

One way is to simply attach WinDbg to your running process and use the following steps.

 

Once you have attached to the process load the sos.dll:

.load C:\Windows\Microsoft.NET\Framework\v4.0.30319\sos.dll

 

Change the above to match your .Net version and architecture (x64/x86).

Then create a breakpoint on the Stackoverflow exception:

 

!stoponexception -create System.StackOverflowException

 

Then start the process again, F5 or type g.

When the application stops, the debugger will do report something like this:

 

(115c.4d0): Stack overflow - code c00000fd (first chance)

First chance exceptions are reported before any exception handling.

This exception may be expected and handled.

eax=02b6dca8 ebx=0279b39c ecx=02b6dca8 edx=0279d1e8 esi=0279d1e8 edi=0279d1e8

eip=004b0253 esp=00063000 ebp=00063000 iopl=0         nv up ei pl nz na po nc

cs=0023  ss=002b  ds=002b  es=002b  fs=0053  gs=002b             efl=00010202

004b0253 57              push    edi

 

So here it clearly shows that we have a stackoverflow. Save a dump to disk for later examination:

 

.dump /ma C:\Dumps\Stackoverflowdump.dmp

 

or investigate directly by running !clrstack.

In my case we can see that the recursion comes from the constructor in ToYoungException (StackOverflowDemo.ToYoungException..ctor)

calling the GetAge method on the Person instance which triggers the exception which triggers the constructor which calls GetAge etc.

 

0:000> !clrstack

OS Thread Id: 0x4d0 (0)

Child SP IP       Call Site

00063000 004b0253 StackOverflowDemo.ToYoungException..ctor(StackOverflowDemo.Person)*** WARNING: Unable to verify checksum for <processname>.exe

00063008 004b0236 StackOverflowDemo.Person.GetAge()

00063014 004b0273 StackOverflowDemo.ToYoungException..ctor(StackOverflowDemo.Person)  

00063028 004b0236 StackOverflowDemo.Person.GetAge()

00063034 004b0273 StackOverflowDemo.ToYoungException..ctor(StackOverflowDemo.Person)  

00063048 004b0236 StackOverflowDemo.Person.GetAge()

00063054 004b0273 StackOverflowDemo.ToYoungException..ctor(StackOverflowDemo.Person)  

00063068 004b0236 StackOverflowDemo.Person.GetAge()

00063074 004b0273 StackOverflowDemo.ToYoungException..ctor(StackOverflowDemo.Person)  

00063088 004b0236 StackOverflowDemo.Person.GetAge()

 

Hope this helps someone.

 

 

 

 

 

 

 

 

Leave a Comment
  • Please add 2 and 2 and type the answer here:
  • Post
  • Explain how to load sos dll and how to create a break point using ur conditions.

Page 1 of 1 (1 items)